﻿//{$WARNINGS OFF}
//{$WARN SYMBOL_PLATFORM OFF}
//{$WARN UNIT_PLATFORM OFF}
//=============================================================================
//  ショートカットキー送信テスト用のプログラム
//  コマンドプロンプ用
//
//-----------------------------------------------------------------------------
//
//  【使用条件等】
//
//  当サイトのアプリケーション類，コンポーネント，コード類は，転載，改変，配布
//  (オリジナル，改変版)などは全て自由です．商用利用も自由です．連絡，使用の記
//  載義務もありません．ただしオリジナルそのものを商用とすることは禁止します．
//  なお，本サイトのプログラムやコードを使用したことによって生じた，いかなる障
//  害，損失に関しても作者は一切関与しないものとします．ご了承下さい．
//
//-----------------------------------------------------------------------------
//
//  【履歴】
//
//  2021年08月04日 ～
//
//-----------------------------------------------------------------------------
//
//  【動作確認環境】
//
//  Windows [Version 10.0.19042] Pro 64 bit + Delphi XE5(UP2) Pro VCL-32
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit SendShortCurKeyUnit;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes,
  Vcl.Graphics, Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Memo1: TMemo;
    Edit1: TEdit;
    Button2: TButton;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
  private
    { Private 宣言 }
  public
    { Public 宣言 }
  end;

  function AttachConsole(dwProcess: DWORD): BOOL; stdcall; external 'kernel32.dll';

  // 単独で使用する場合を考慮して，クラスのメンバではなくここで宣言
  procedure SendKeysCmdMain(ACmdWnd: HWND; ATextKeysCmd: string);
  procedure SendCommandPrompt(ACmdWnd: HWND; ACmdLine: string);
  procedure SendYYesNo(ACmdWnd: HWND; AProcessID: Cardinal);

var
  Form1: TForm1;

implementation

uses
  Winapi.ShellAPI,
  System.StrUtils,
  plSendShortCut;

{$R *.dfm}

const
  FCmdTitle = 'コマンド送信テスト';

//=============================================================================
//  フォーム生成時の処理
//=============================================================================
procedure TForm1.FormCreate(Sender: TObject);
begin
  Caption := 'コマンドプロンプトへの送信テスト';
  Memo1.Lines.Clear;
  Memo1.Lines.Add('Ctrl+A');
  Memo1.Lines.Add('Alt+Space+E+Y');

  Edit1.Text := 'cmd';
  Edit1.AutoSelect := False;
end;

//=============================================================================
//  フォームを閉じる時の処理
//  このプログラムから起動したコマンドプロンプトは閉じる
//  起動したコマンドプロンプトは，タイトルで判定する
//=============================================================================
procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
var
  LTitle    : string;
  LhCmdWnd : HWND;
begin
  LhCmdWnd := FindWindow('ConsoleWindowClass', PChar(FCmdTitle));
  if LhCmdWnd = 0 then begin
    LTitle:= '管理者:  ' + FCmdTitle;
    LhCmdWnd := FindWindow('ConsoleWindowClass', PChar(LTitle));
  end;
  if LhCmdWnd <> 0 then begin
    PostMessage(LhCmdWnd, WM_CLOSE, 0, 0);
  end;
end;

//=============================================================================
//  TEdit のテキストをショートカットまたはコマンドとして実行
//  TEdit のテキストが cmd の時はコマンドプロンプトを起動
//=============================================================================
procedure TForm1.Button1Click(Sender: TObject);
var
  LCmdWnd : HWND;
  LText   : string;
begin
  if Edit1.Text = 'cmd' then begin
    LCmdWnd := FindWindow('ConsoleWindowClass', nil);
    if LCmdWnd <> 0 then begin
      LText := 'コマンドプロンプトは起動しています。';
      MessageBox(Handle, PChar(lText), '起動中', MB_ICONINFORMATION);
    end else begin
      // 起動したコマンドプロンプトを見つけやすいように独自のタイトルを設定
      // このタイトルを使用して自分が起動したコマンドプロンプトを見つける
      LText := '/k title コマンド送信テスト';
      ShellExecute(Handle, '', 'cmd.exe', PChar(LText), nil, SW_SHOWNORMAL);
      Sleep(100);
      SetForegroundWindow(Handle);
    end;
    Edit1.Text := 'dir';
    Edit1.SetFocus;
    Exit;
  end;


  // コマンドプロンプトのウインドウハンドルを取得
  LCmdWnd := FindWindow('ConsoleWindowClass', nil);
  if LCmdWnd = 0 then begin
    LText := 'コマンドプロンプトが起動していません。';
    MessageBox(Handle, PChar(lText), '失敗', MB_ICONINFORMATION);
    Exit;
  end;


  LText := Edit1.Text;
  if Trim(LText) <> '' then begin
    SendkeysCmdMain(LCmdWnd, LText);
  end;
  SetForegroundWindow(Handle);
  Edit1.SetFocus;
end;

//=============================================================================
//  Tmemo のテキストを行単位でショートカットまたはコマンドとして実行
//=============================================================================
procedure TForm1.Button2Click(Sender: TObject);
var
  LCmdWnd : HWND;
  LText   : string;
  LIndex  : Integer;
begin
  // コマンドプロンプトのウインドウハンドルを取得
  LCmdWnd := FindWindow('ConsoleWindowClass', nil);
  if LCmdWnd = 0 then begin
    LText := 'コマンドプロンプトが起動していません。';
    MessageBox(Handle, PChar(lText), '失敗', MB_ICONINFORMATION);
    Exit;
  end;


  for LIndex :=0 to Memo1.Lines.Count - 1 do begin
    LText := Memo1.Lines[LIndex];
    if Trim(LText) <> '' then begin
      SendkeysCmdMain(LCmdWnd, LText);
    end;
  end;
  SetForegroundWindow(Handle);
  Memo1.SetFocus;
end;

//=============================================================================
//  Edit1 の OnKeyPress イベント処理
//  [Enter] キーでコマンド実行
//=============================================================================
procedure TForm1.Edit1KeyPress(Sender: TObject; var Key: Char);
begin
  if Key = Char(VK_RETURN) then begin
    Button1Click(nil);
  end;
end;

//-----------------------------------------------------------------------------
//  メインルーチン
//
//  ACmdWnd      : コマンドプロンプトのウィンドウハンドル または
//                 ショートカットキーを受信するウィンドウのハンドル
//  ATextKeysCmd : ショートカットキーまたはコマンドプロンプト用のコマンド
//
//  ショートカットの文字列は仮想キーコード名と英数字の組み合わせ
//  各キー名の間に + を挿入する．+ の両端に空白があってもよい
//  アクセレーターキーも使用可能
//  複数のショートカットキーは指定できない
//  例 : Alt+F+A (メモ帳の場合は [名前を付けて保存] のダイアログを表示)
//
//  コマンドプロント用のコマンドは & を使用して複数指定可能
//-----------------------------------------------------------------------------
procedure SendKeysCmdMain(ACmdWnd: HWND; ATextKeysCmd: string);
const
  ATTACH_PARENT_PROCESS = DWORD(-1);
var
  LProcessID : HWND;
  LSendText  : string;
begin

  GetWindowThreadProcessId(ACmdWnd, @LProcessID);
  LSendText := GetShorCutChars(ATextKeysCmd);

  if LSendText = '' then begin
    // コンソールのスレッドにアタッチ
    if AttachConsole(LProcessID) then begin
      // コマンド実行
      SendCommandPrompt(ACmdWnd, ATextKeysCmd);
      // FreeConsole でデアタッチ
      FreeConsole;
    end;
  end else begin
    // キー操作を送信
    SendShortCutKey(ACmdWnd, LSendText);

    if LSendText = #$11#$43 then begin
      // (y/n) のテキストが完全に表示されるまでは少しタイムラグがある
      // タイムラグは実行するコマンド (EXE, BAT 等)の処理内容による
      // どうせブレークなので多少長くても問題はないだろう
      Sleep(100);
      // (y/n) に y で自動応答する
      SendYYesNo(ACmdWnd, LProcessID);
    end;
  end;
end;

//-----------------------------------------------------------------------------
//  標準入力 (コマンドプロンプト) にコマンドのテキストを送信して実行する
//  この手続きはコンソールのスレッドにアタッチしていないと機能しない
//
//  ACmdWnd    : 対象のコマンドプロンプトのウィンドウハンドル
//  ACmdLine   : そのコマンドプロンプトで実行するコマンドラインのテキスト
//               複数のコマンドを実行する場合は，コマンドを & で結合する
//-----------------------------------------------------------------------------
procedure SendCommandPrompt(ACmdWnd: HWND; ACmdLine: string);
var
  LhStdInput : THandle;
  LInputRec  : TInputRecord;
  LEventNum  : DWORD;
  LIndex     : Integer;
begin
  // 標準入力のハンドルを取得
  LhStdInput := GetStdHandle(STD_INPUT_HANDLE);

  FillChar(LInputRec, SizeOf(LInputRec), #0);
  LInputRec.EventType := KEY_EVENT;
  LInputRec.Event.KeyEvent.wRepeatCount := 1;
  LInputRec.Event.KeyEvent.bKeyDown     := True;

  // Delphi の String 型は最初の文字が入った要素番号は 1
  for LIndex := 1  To Length(ACmdLine) do begin
    LInputRec.Event.KeyEvent.UnicodeChar := ACmdLine[Lindex];
    WriteConsoleInput(LhStdInput, LInputRec, 1, LEventNum );
  end;
  Application.ProcessMessages;
  Sleep(10);

  // [Enter] キーの送信
  // KEYUP は LParam の値を調整して WM_KEYDOWN メッセージで処理
  PostMessage(ACmdWnd, WM_KEYDOWN, VK_RETURN, $001C0001);
  PostMessage(ACmdWnd, WM_KEYDOWN, VK_RETURN, $C01C0001);
end;

//-----------------------------------------------------------------------------
//  ブレーク処理の時の y/n の選択で自動的に y を送信する処理
//  コンソールに表示されているテキストの最後の行の文字列で判定する
//  uses に StrUtils が必要
//
//  ACmdWnd    : 対象のコマンドプロンプトのウィンドウハンドル
//  AProceddID : その ProcessID の値
//-----------------------------------------------------------------------------
procedure SendYYesNo(ACmdWnd: HWND; AProcessID: Cardinal);
var
  LhStdOutput : THandle;
  LBufferInfo : TConsoleScreenBufferInfo;
  LpCaracter  : PChar;
  LCurCoord   : TCoord;
  LTextLength : Cardinal;
  LReadCnt    : Cardinal;
  LLineText   : string;
begin
  LLineText := '';

  // コンソールのスレッドにアタッチして標準出力のハンドルを取得
  if AttachConsole(AProcessID) then begin
    LhStdOutput := GetStdHandle(STD_OUTPUT_HANDLE);

    // バッファの情報を取得
    GetConsoleScreenBufferInfo (LhStdOutput, LBufferInfo);

    LTextLength := LBufferInfo.dwSize.X;
    // メモリの確保(PChar型で受け取る時はメモリの確保が必要)
    GetMem(LpCaracter, LTextLength);
    try
      // バッファの値の読み取り位置
      // X 座標は左端
      // Y 座標はカーソルがある行 (最下行 - 先頭行は 1)
      LCurCoord.X := 0;
      LCurCoord.Y := LBufferInfo.dwCursorPosition.Y;
      // 標準出力バッファの内容を読み出す
      if ReadConsoleOutputCharacter(LhStdOutput,
                                    LpCaracter,
                                    LTextLength,
                                    LCurCoord,
                                    LReadCnt) then begin
        // 読み出した分だけにしないと後部にゴミが入ることがある
        LLineText := Copy(LpCaracter, 1, LReadCnt);
      end;
    finally
      FreeMem(LpCaracter);
    end;
  end;

  // 最後の行文字列に (y/n) の文字列があるかチェック (大文字小文字の区別なし)
  // SendCommandPrompt はコンソールのスレッドにアタッチしていないと機能しない
  if ContainsText(LLineText, '(y/n)') then begin
    SendCommandPrompt(ACmdWnd, 'Y');
  end;


  // FreeConsole でデアタッチ
  FreeConsole;
end;

end.
